// snmpdlg.cpp : implementation file
//

#include "stdafx.h"
#include <mgmtapi.h>
#include "util.h"
#include "snmp.h"
#include "snmpdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



CTreeCtrl idcTree;
CStatic idcOid, idcName, idcType, idcValue;



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SnmpDlg dialog

SnmpDlg::SnmpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(SnmpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(SnmpDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void SnmpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SnmpDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(SnmpDlg, CDialog)
	//{{AFX_MSG_MAP(SnmpDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD, OnOpen)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE, OnSelchangedTree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SnmpDlg message handlers

BOOL SnmpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	idcTree.SubclassDlgItem( IDC_TREE, this );
	idcOid.SubclassDlgItem( IDC_OID, this );
	idcName.SubclassDlgItem( IDC_NAME, this );
	idcType.SubclassDlgItem( IDC_TYPE, this );
	idcValue.SubclassDlgItem( IDC_VALUE, this );


	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void SnmpDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void SnmpDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR SnmpDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void SnmpDlg::error( ccp fmt, ... )
{
	char buf[2000];
	va_list args;

	va_start( args, fmt );
	_vsnprintf( buf, sizeof buf - 1, fmt, args );
	va_end( args );

	AfxMessageBox( buf, MB_OK | MB_ICONSTOP, 0 );
}

void SnmpDlg::OnOpen() 
{
	int rc;
	static char sysdir[256] = "";
	ccp defaultFile = "inetmib1.dll";

	CFileDialog fd( TRUE, ".dll", defaultFile, OFN_FILEMUSTEXIST | OFN_READONLY,
		"DLLs (*.dll)|*.dll|All files (*.*)|*.*||", this );

	if ( *sysdir == '\0' )
	{
		GetSystemDirectory( sysdir, sizeof sysdir );
		SetCurrentDirectory( sysdir );
	}

	if ( IsDebuggerPresent() )
	{
		currentFile = defaultFile;
	}
	else
	{
		rc = fd.DoModal();
		if ( rc == IDCANCEL )
		{
			DWORD rc2;
			rc2 = CommDlgExtendedError();
			if ( rc2 == 0 )
				return;
			else
			{
				// common dialog error, but who cares?
				error( "The \"Open File\" dialog returned an extended error %lu.", rc2 );
				return;
			}
		}
		currentFile = fd.GetPathName();
	}

	openEA( currentFile );
}

void SnmpDlg::OnOK() 
{
	CDialog::OnOK();
	EndDialog( 0 );
}

void SnmpDlg::openEA(ccp fileName)
{
	CString msg;
	AsnObjectIdentifier aoi;
	Node *n;

	msg = CString( "Opening " ) + fileName + " ...";
	SetDlgItemText( IDC_FILENAME, msg );

	idcOid.SetWindowText( "" );
	idcName.SetWindowText( "" );
	idcType.SetWindowText( "" );
	idcValue.SetWindowText( "" );
	
	root.killChildren();
	idcTree.DeleteAllItems();

	if ( hLib != NULL )
	{
		FreeLibrary( hLib );
		hLib = NULL;
	}

	hLib = LoadLibrary( fileName );
	if ( hLib == NULL )
	{
		error( "\"%s\" cannot be loaded. GLE == %lu", fileName, gle );
		SetDlgItemText( IDC_FILENAME, "" );
		return;
	}

	// get function pointers
	sei = (PSEI) GetProcAddress( hLib, "SnmpExtensionInit" );
	seie = (PSEIE) GetProcAddress( hLib, "SnmpExtensionInitEx" );
	seq = (PSEQ) GetProcAddress( hLib, "SnmpExtensionQuery" );
	if ( sei == NULL || seq == NULL )
	{
		error( "SnmpExtensionInit() or SnmpExtensionQuery() not found; "
			"is \"%s\" really an SNMP Extension Agent?", fileName );
cleanup:
		FreeLibrary( hLib );
		hLib = NULL;
		SetDlgItemText( IDC_FILENAME, "" );
		return;
	}

	// intialize DLL, get first MIB subtree
	root.hti = idcTree.InsertItem( fileName, TVI_ROOT, TVI_LAST );
	idcTree.SetItemData( root.hti, (DWORD) &root );
	root.isFake = true;

	HANDLE dummy;
	if ( ! sei( 0, &dummy, &aoi ) )
	{
		error( "SnmpExtensionInit() failed. Bah!" );
		goto cleanup; // I *told* you I was lazy!
	}
	n = root.addChild( aoi );
	n->enumSubtree();

	// get any additional subtrees
	while ( seie != NULL ) // basically forever if this function is present
	{
		if ( ! seie( &aoi ) )
			break;
		n = root.addChild( aoi );
		n->enumSubtree();
	}

	// initialize treeview, set focus to root

	SetDlgItemText( IDC_FILENAME, fileName );
}



void SnmpDlg::OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*) pNMHDR;
	Node& n = *( (Node *) pNMTreeView->itemNew.lParam );
	LPSTR pStr, t, p, q;

	if ( &n == &root )
	{
		idcOid.SetWindowText( "[Agent root, no OID]" );
		idcName.SetWindowText( "" );
		idcType.SetWindowText( "" );
		idcValue.SetWindowText( "" );
	}
	else
	{
		// display:
		// OID
		idcOid.SetWindowText( (ccp) (CString) n );

		// full name
		SnmpMgrOidToStr( &n.aoi, &pStr );
		t = (char *) malloc( strlen( pStr ) * 2 );
		for ( p = pStr, q = t; p != NULL && *p != '\0'; ++ p )
		{
			*( q ++ ) = *p;
			if ( *p == '.' )
				*( q ++ ) = ' '; // so the static control can wordwrap this
		}
		*q = '\0';
		idcName.SetWindowText( t );
		SnmpUtilMemFree( pStr );
		free( t );

		// value type
		idcType.SetWindowText( n.val.getType() );

		// value
		idcValue.SetWindowText( (CString) n.val );
	}

	*pResult = 0;
}
