// util.h: interface for the Utility classes.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UTIL_H__D1A040B6_9EA1_11D2_BD39_00104B449F19__INCLUDED_)
#define AFX_UTIL_H__D1A040B6_9EA1_11D2_BD39_00104B449F19__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#define gle (GetLastError())
#define lenof(x) (sizeof(x) / sizeof((x)[0]))
#define NO_TRAILING_ZERO_IN_OID 1



typedef const char *ccp;



void ods( ccp fmt, ... );



// SnmpExtensionInit()
typedef BOOL (SNMP_FUNC_TYPE *PSEI)( DWORD dwUptimeReference,
	HANDLE *phSubagentTrapEvent, AsnObjectIdentifier *pFirstSupportedRegion );
// SnmpExtensionInitEx
typedef BOOL (SNMP_FUNC_TYPE *PSEIE)( AsnObjectIdentifier *pNextSupportedRegion );
// SnmpExtensionQuery
typedef BOOL (SNMP_FUNC_TYPE *PSEQ)( BYTE bPduType, SnmpVarBindList *pVarBindList,
	AsnInteger32 *pErrorStatus, AsnInteger32 *pErrorIndex );



extern PSEI sei; // ptr to SnmpExtensionInit()
extern PSEIE seie; // ptr to SnmpExtensionInitEx()
extern PSEQ seq; // ptr to SnmpExtensionQuery()



class AA: public AsnAny
{
	// ctors, assignment, dtor
public:
	AA();
	AA( const AA& a );
	AA( const AsnAny& a );
	AA& operator=( const AA& a );
	AA& operator=( const AsnAny& a );
	~AA();

	// casts and conversions
	operator AsnAny&();
	operator const AsnAny&();
	operator CString() const;

	CString getType() const;

	free(); // releases memory, then clear()

protected:
	clear(); // zeros contents, no mem freed
};



class AOI: public AsnObjectIdentifier
{
	// ctors, assignment, dtor
public:
	AOI();
	AOI( const AOI& a );
	AOI( const AsnObjectIdentifier& a );
	AOI( ccp src );
	AOI( UINT n, const UINT *newids );
	AOI& operator=( const AOI& a );
	AOI& operator=( const AsnObjectIdentifier& a );
	AOI& operator=( ccp src );
	~AOI();

	// casts and conversions
	operator AsnObjectIdentifier *();
	operator AsnObjectIdentifier&();
	operator const AsnObjectIdentifier&() const;
	operator CString() const; // returns OID in string form
	operator UINT() const; // returns last element of the OID

	free(); // releases memory, then clear()

protected:
	clear(); // zeros contents, no mem freed
};



class Node
{
	// make everything public. After all, it's just a sample.
public:
	AOI aoi; // OID
	AA val; // the value assiciated with this OID
	HTREEITEM hti; // treeitem handle when in UI
	bool isFake; // true if this entry was not in the MIB
	int maxChildren; // max number of Node* in children[]
	int numChildren; // current number of Node* in children[]
	Node **children;

	Node(): hti( NULL ), isFake( false ), maxChildren( 0 ), numChildren( 0 ), children( NULL ) { }
	~Node();
	Node( const Node& n );
	operator=( const Node& n );

	operator CString() const; // returns OID of aoi in string form

	void enumSubtree();
	Node *insert( AOI& a );
	Node *addChild( const AOI& a, bool isFakeChild = false );
	Node *findChild( UINT what ); // find a child of this node by ID
	void killChildren();
};



#endif // !defined(AFX_UTIL_H__D1A040B6_9EA1_11D2_BD39_00104B449F19__INCLUDED_)
